import React, { useState, useEffect } from "react";
import ReactDOM from "react-dom"; //import Button from "@material-ui/core/Button";

import { useLocation } from "react-router-dom";
import { Form, Row, Col, Button } from "react-bootstrap";
import axios from "axios";

function OnboardPlanetOrgTest(props) {
  const location = useLocation();
  const [planetOrgEnvHostData, setPlanetOrgEnvHostData] = useState({
    orgName: "",
    credential: "",
    env: [{
      name: "",
      vhost: [{
        envName: "",
        name: "",
        protocol: "",
        port: "",
        cname: ""
      }]
    }]
  }); //add environment

  const addEnvironment = e => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env.push({
      name: "",
      vhost: [{
        envName: "",
        name: "",
        protocol: "",
        port: "",
        cname: ""
      }]
    });
    setPlanetOrgEnvHostData(temp);
  }; //add vhost


  const addVhost = (e, i) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost.push({
      envName: "",
      name: "",
      protocol: "",
      port: "",
      cname: ""
    });
    setPlanetOrgEnvHostData(temp);
  }; //remove environment


  const deleteEnvironment = (e, i) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env.splice(i, 1);
    setPlanetOrgEnvHostData(temp);
  }; //remove vhost


  const deleteVhost = (e, i, j) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost.splice(j, 1);
    setPlanetOrgEnvHostData(temp);
  }; //planet org name change


  const handleOrgNameChange = e => {
    let temp = { ...planetOrgEnvHostData
    };
    temp[e.target.name] = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //planet org credential change


  const handleOrgCredentialChange = e => {
    let temp = { ...planetOrgEnvHostData
    };
    temp[e.target.name] = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //environment name change


  const handleEnvironmentNameChange = (e, i) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i][e.target.name] = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //vhost name change


  const handleVhostNameChange = (e, i, j) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost[j].name = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //vhost envName change


  const handleVhostEnvNameChange = (e, i, j) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost[j].envName = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //vhost protocol change


  const handleVhostProtocolChange = (e, i, j) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost[j].protocol = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //vhost port change


  const handleVhostPortChange = (e, i, j) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost[j].port = e.target.value;
    setPlanetOrgEnvHostData(temp);
  }; //vhost cname change


  const handleVhostCnameChange = (e, i, j) => {
    let temp = { ...planetOrgEnvHostData
    };
    temp.env[i].vhost[j].cname = e.target.value;
    setPlanetOrgEnvHostData(temp);
  };

  const onboardPlantOrgSubmitHandler = e => {
    console.log(planetOrgEnvHostData);
    axios.post(`https://configurator-api-m7mkmev5sq-uc.a.run.app/planet/${new URLSearchParams(location.search).get("planetId")}/orgs`, planetOrgEnvHostData).then(res => {
      console.log(res);
    }).catch(err => {
      console.log(err.message);
    });
  };

  return /*#__PURE__*/React.createElement("section", null, /*#__PURE__*/React.createElement("div", {
    className: "developer-list-page"
  }, /*#__PURE__*/React.createElement("div", {
    className: "container"
  }, /*#__PURE__*/React.createElement("div", {
    className: "col-sm-12"
  }, /*#__PURE__*/React.createElement("h2", null, "Onboard Org"), /*#__PURE__*/React.createElement("ul", {
    className: "breadcrumb"
  }, /*#__PURE__*/React.createElement("li", {
    className: "breadcrumb-item"
  }, /*#__PURE__*/React.createElement("a", {
    href: "/"
  }, "Home")), /*#__PURE__*/React.createElement("li", {
    className: "breadcrumb-item active"
  }, /*#__PURE__*/React.createElement("a", {
    href: "/"
  }, "Onboard Org")))))), /*#__PURE__*/React.createElement("main", {
    id: "main mt-5"
  }, /*#__PURE__*/React.createElement("section", {
    id: "subpage",
    className: "wow fadeInUp"
  }, /*#__PURE__*/React.createElement("div", {
    className: "upload-swagger"
  }, /*#__PURE__*/React.createElement("div", {
    className: "container"
  }, /*#__PURE__*/React.createElement("div", {
    className: "row form-section nopadding"
  }, /*#__PURE__*/React.createElement("div", {
    className: "col-lg-3"
  }, props.leftNavigation), /*#__PURE__*/React.createElement("div", {
    className: "col-lg-9 col-sm-12 swag-border-left"
  }, /*#__PURE__*/React.createElement("div", {
    className: "pageHeaders"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mb-3"
  }, /*#__PURE__*/React.createElement(Form, null, /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgName"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Org Name ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "orgName",
    onChange: handleOrgNameChange,
    value: planetOrgEnvHostData.orgName
  }))), /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgCredential"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Credential ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "credential",
    onChange: handleOrgCredentialChange,
    value: planetOrgEnvHostData.credential
  }))), /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement("strong", null, "Add Environment(s):")), planetOrgEnvHostData.env.map((envts, i) => /*#__PURE__*/React.createElement("div", {
    className: "group-field-highlight-pattern-info"
  }, /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgEnvironmentName"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Name ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement("div", {
    className: "row org-button"
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "name",
    onChange: e => handleEnvironmentNameChange(e, i),
    value: planetOrgEnvHostData.env[i].name
  }), /*#__PURE__*/React.createElement(Button, {
    variant: "secondary",
    onClick: e => deleteEnvironment(e, i)
  }, "-Env")))), /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement("strong", null, "VHost(s):")), envts.vhost.map((host, j) => /*#__PURE__*/React.createElement("div", {
    className: "group-field-highlight-org-info"
  }, /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgVhostname"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Name ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement("div", {
    className: "row org-button"
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "name",
    onChange: e => handleVhostNameChange(e, i, j),
    value: planetOrgEnvHostData.env[i].vhost[j].name
  }), /*#__PURE__*/React.createElement(Button, {
    variant: "secondary",
    onClick: e => deleteVhost(e, i, j)
  }, "-Vhost")))), /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgVhostEnvName"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "envName ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "envName",
    onChange: e => handleVhostEnvNameChange(e, i, j),
    value: planetOrgEnvHostData.env[i].vhost[j].envName
  }))), /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgVhostProtocol"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Protocol ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "protocol",
    onChange: e => handleVhostProtocolChange(e, i, j),
    value: planetOrgEnvHostData.env[i].vhost[j].protocol
  }))), /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgVhostPort"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Port ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "port",
    onChange: e => handleVhostPortChange(e, i, j),
    value: planetOrgEnvHostData.env[i].vhost[j].port
  }))), /*#__PURE__*/React.createElement(Form.Group, {
    as: Row,
    controlId: "onboardOrgVhostCname"
  }, /*#__PURE__*/React.createElement(Form.Label, {
    column: true,
    sm: 2
  }, "Cname ", /*#__PURE__*/React.createElement("span", {
    className: "required"
  }, "*")), /*#__PURE__*/React.createElement(Col, {
    sm: 10
  }, /*#__PURE__*/React.createElement(Form.Control, {
    type: "text",
    className: "w-75",
    name: "cname",
    onChange: e => handleVhostCnameChange(e, i, j),
    value: planetOrgEnvHostData.env[i].vhost[j].cname
  }))))), /*#__PURE__*/React.createElement(Button, {
    variant: "primary",
    onClick: e => addVhost(e, i)
  }, "+Vhost")))), /*#__PURE__*/React.createElement(Button, {
    variant: "primary",
    onClick: addEnvironment
  }, "+Env"), " ", /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement("br", null), /*#__PURE__*/React.createElement(Button, {
    variant: "primary",
    onClick: onboardPlantOrgSubmitHandler
  }, "Create"))))))))));
}

export default OnboardPlanetOrgTest;